---
title: Building up a basic demo with Babylon.js
slug: Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Babylon.js
tags:
  - 3D game engines
  - Babylon.js
  - Beginner
  - WebGL
---
<div>{{GamesSidebar}}</div><p class="summary"><span class="seosummary"><a href="http://babylonjs.com/">Babylon.js</a> is one of the most popular 3D game engines used by developers. As with any other 3D library it provides built-in functions to help you implement common 3D functionality more quickly. In this article we'll take you through the real basics of using Babylon.js, including setting up a development environment, structuring the necessary HTML, and writing the JavaScript code.</span></p>

<p>We will try to create a simple demo first — a cube rendered on the screen. If you have already worked through our <em>Building up a basic demo</em> <a href="/en-US/docs/Games/Techniques/3D_on_the_web">series</a> with <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Three.js">Three.js</a>, <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_PlayCanvas">PlayCanvas</a> or <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_A-Frame">A-Frame</a> (or you are familiar with other 3D libraries) you'll notice that Babylon.js works on similar concepts: camera, light and objects.</p>

<h2 id="Environment_setup">Environment setup</h2>

<p>To start developing with Babylon.js, you don't need much. You should start off by:</p>

<ul>
 <li>Making sure you are using a modern browser with good <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> support, such as the latest Firefox or Chrome.</li>
 <li>Creating a directory to store your experiments in.</li>
 <li>Saving a copy of the <a href="http://cdn.babylonjs.com/2-3/babylon.js">latest Babylon.js engine</a> inside your directory.</li>
 <li>Opening the <a href="http://doc.babylonjs.com/">Babylon.js documentation</a> in a separate tab — it is useful to refer to.</li>
</ul>

<h2 id="HTML_structure">HTML structure</h2>

<p>Here's the HTML structure we will use: </p>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;meta charset="utf-8"&gt;
    &lt;title&gt;MDN Games: Babylon.js demo&lt;/title&gt;
    &lt;style&gt;
        html,body,canvas { margin: 0; padding: 0; width: 100%; height: 100%; font-size: 0; }
    &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;script src="babylon.js"&gt;&lt;/script&gt;
&lt;canvas id="render-canvas"&gt;&lt;/canvas&gt;
&lt;script&gt;
    var canvas = document.getElementById("render-canvas");
    /* all our JavaScript code goes here */
&lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>It contains some basic information like the document {{htmlelement("title")}}, and some CSS to set the width and height of the {{htmlelement("canvas")}} element (which Babylon.js will use to render the content on) to fill the entire available viewport space. The first {{htmlelement("script")}} element includes the Babylon.js library in the page; we will write our example code in the second one. There is one helper variable already included, which will store a reference to the <code>&lt;canvas&gt;</code> element.</p>

<p>Before reading on, copy this code to a new text file and save it in your working directory as <code>index.html</code>.</p>

<h2 id="Initialising_the_Babylon.js_engine">Initialising the Babylon.js engine</h2>

<p>We have to create a Babylon.js engine instance first (passing it the <code>&lt;canvas&gt;</code> element to render on) before we start developing our game. Add the following code to the bottom of your second <code>&lt;script&gt;</code> element:</p>

<pre class="brush: js">var engine = new BABYLON.Engine(canvas);
</pre>

<p>The <code>BABYLON</code> global object contains all the Babylon.js functions available in the engine.</p>

<h2 id="Creating_a_scene">Creating a scene</h2>

<p>A scene is the place where all the game content is displayed. While creating new objects in the demo, we will be adding them all to the scene to make them visible on the screen. Let's create a scene by adding the following lines just below our previous code:</p>

<pre class="brush: js">var scene = new BABYLON.Scene(engine);
scene.clearColor = new BABYLON.Color3(0.8, 0.8, 0.8);
</pre>

<p>Thus, the scene is created and the second line sets the background color to light gray.</p>

<h2 id="Creating_a_rendering_loop">Creating a rendering loop</h2>

<p>To make the scene actually visible we have to render it. Add these lines at the end of the <code>&lt;script&gt;</code> element, just before the closing <code>&lt;/script&gt;</code>.</p>

<pre class="brush: js">var renderLoop = function () {
    scene.render();
};
engine.runRenderLoop(renderLoop);
</pre>

<p>We're using the engine's <code>runRenderLoop()</code> method to execute the <code>renderLoop()</code> function repeatedly on every frame — the loop will continue to render indefinitely until told to stop.</p>

<h2 id="Creating_a_camera">Creating a camera</h2>

<p>Now the setup code is in place we need to think about implementing the standard scene components: camera, light and objects. Let's start with the camera — add this line to your code below the scene creation and the line where we defined the <code>clearColor</code>.</p>

<pre class="brush: js">var camera = new BABYLON.FreeCamera("camera", new BABYLON.Vector3(0, 0, -10), scene);
</pre>

<p>There are many <a href="http://doc.babylonjs.com/tutorials/Cameras">cameras</a> available in Babylon.js; <code>FreeCamera</code> is the most basic and universal one. To initialize it you need to pass it three parameters: any name you want to use for it, the coordinates where you want it to be positioned in the 3D space, and the scene you want to add it to.</p>

<div class="note">
<p><strong>Note</strong>: You probably noticed the <code>BABYLON.Vector3()</code> method in use here — this defines a 3D position on the scene. Babylon.js is bundled with a complete math library for handling vectors, colors, matrices etc.</p>
</div>

<h2 id="Let_there_be_light">Let there be light</h2>

<p>There are various <a href="http://doc.babylonjs.com/tutorials/Lights">light sources</a> available in Babylon.js. The most basic one is the <code>PointLight</code>, which works like a flashlight — shining a spotlight in a given direction. Add the following line below your camera definition: </p>

<pre class="brush: js">var light = new BABYLON.PointLight("light", new BABYLON.Vector3(10, 10, 0), scene);
</pre>

<p>The parameters are very similar to the previously defined camera: the name of the light, a position in 3D space and the scene to which the light is added.</p>

<h2 id="Geometry">Geometry</h2>

<p>Now the scene is properly rendering we can start adding 3D shapes to it. To speed up development Babylon.js provides a bunch of <a href="http://doc.babylonjs.com/tutorials/Discover_Basic_Elements">predefined primitives</a> that you can use to create shapes instantly in a single line of code. There are cubes, spheres, cylinders and more complicated shapes available. Let's start by defining the geometry for a box shape — add the following new code below your previous additions:</p>

<pre class="brush: js">var box = BABYLON.Mesh.CreateBox("box", 2, scene);
</pre>

<p>A mesh is a way the engine creates geometric shapes, so material can be easily applied to them later on. In this case we're creating a box using the <code>Mesh.CreateBox</code> method with it's own name, a size of 2, and a declaration of which scene we want it added to.</p>

<div class="note">
<p><strong>Note</strong>: The size or position values (e.g. for the box size) are unitless, and can basically be anything you deem suitable for your scene — milimeters, meters, feet, or miles — it's up to you.</p>
</div>

<p>If you save and refresh now, your object will look like a square, because it's facing the camera. The good thing about objects is that we can move them on the scene however we want, for example rotating and scaling. Let's apply a little bit of rotation to the box, so we can see more than one face — again, add these lines below the previous one:</p>

<pre class="brush: js">box.rotation.x = -0.2;
box.rotation.y = -0.4;
</pre>

<p>The box looks black at the moment, because we haven't defined any material to apply to its faces. Let's deal with that next.</p>

<h2 id="Material">Material</h2>

<p>Material is that thing covering the object — the colors or texture on its surface. In our case we will use a simple blue color to paint our box. There are many types of <a href="http://doc.babylonjs.com/tutorials/Materials">materials</a> that can be used, but for now the standard one should be enough for us. Add these lines below the previous ones:</p>

<pre class="brush: js">var boxMaterial = new BABYLON.StandardMaterial("material", scene);
boxMaterial.emissiveColor = new BABYLON.Color3(0, 0.58, 0.86);
box.material = boxMaterial;
</pre>

<p>The <code>StandardMaterial</code> takes two parameters: a name, and the scene you want to add it to. The second line defines an <code>emissiveColor</code> — the one that will be visible for us. We can use the built-in <code>Color3</code> function to define it. The third line assigns the newly created material to our box.</p>

<p>Congratulations, you've created your first object in a 3D environment using Babylon.js! It was easier than you thought, right? Here's how it should look:</p>

<p><img alt="Blue Babylon.js 3D box on the gray background." src="https://end3r.github.io/MDN-Games-3D/Babylon.js/img/cube.png" style="display: block; height: 490px; margin: 0px auto; width: 600px;"></p>

<p>And here's the code we have created so far:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/9zoeo5sy/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/Babylon.js/cube.html">check it out on GitHub</a>.</p>

<h2 id="More_shapes">More shapes</h2>

<p>We have a box on the scene already; now let's try adding more shapes.</p>

<h3 id="Torus">Torus</h3>

<p>Let's try adding a torus — add the following lines below the previous code:</p>

<pre class="brush: js">var torus = BABYLON.Mesh.CreateTorus("torus", 2, 0.5, 15, scene);
torus.position.x = -5;
torus.rotation.x = 1.5;
</pre>

<p>This will create a torus and add it to the scene; the parameters are: name, diameter, thickness, tessellation (number of segments) and the scene to add it to. We also position it a bit to the left and rotate it on the <code>x</code> axis so it can be seen better. Now let's add a material:</p>

<pre class="brush: js">var torusMaterial = new BABYLON.StandardMaterial("material", scene);
torusMaterial.emissiveColor = new BABYLON.Color3(0.4, 0.4, 0.4);
torus.material = torusMaterial;
</pre>

<p>It looks similar to the box element — we're creating the standard material, giving it a grayish color and assigning it to the torus.</p>

<h3 id="Cylinder">Cylinder</h3>

<p>Creating a cylinder and its material is done in almost exacly the same way as we did for the torus. Add the following code, again at the bottom of your script:</p>

<pre class="brush: js">var cylinder = BABYLON.Mesh.CreateCylinder("cylinder", 2, 2, 2, 12, 1, scene);
cylinder.position.x = 5;
cylinder.rotation.x = -0.2;
var cylinderMaterial = new BABYLON.StandardMaterial("material", scene);
cylinderMaterial.emissiveColor = new BABYLON.Color3(1, 0.58, 0);
cylinder.material = cylinderMaterial;
</pre>

<p>The cylinder parameters are: name, height, diameter at the top, diameter at the bottom, tessellation, height subdivisions and the scene to add it to. It is then positioned to the right of the cube, rotated a bit so its 3D shape can be seen, and given a yellow material.</p>

<p>Here's how the scene should look right now:</p>

<p><img alt="Light gray torus, blue box and yellow cylinder created with Babylon.js on the gray background." src="https://end3r.github.io/MDN-Games-3D/Babylon.js/img/shapes.png" style="display: block; height: 210px; margin: 0px auto; width: 600px;"></p>

<p>This works, but it is a bit boring. In a game something is usually happening — we can see animations and such — so let's try to breathe a little life into those shapes by animating them.</p>

<h2 id="Animation">Animation</h2>

<p>We already used <code>position</code> and <code>rotation</code> to adjust the position of the shapes; we could also scale them. To show actual animation, we need to make changes to these values inside the rendering loop at the end of our code, so they are updated on every frame. Define a helper variable — <code>t</code> — that we will use for animations, just before the <code>renderLoop</code>, and decrement it on every frame inside the loop, like this:</p>

<pre class="brush: js">var t = 0;
var renderLoop = function () {
    scene.render();
    t -= 0.01;
    // animation code goes here
};
engine.runRenderLoop(renderLoop);
</pre>

<p>The <code>t</code> variable will be incremented on every rendered frame.</p>

<h3 id="Rotation">Rotation</h3>

<p>Applying rotation is as easy as adding this line at the end of the <code>renderLoop</code> function:</p>

<pre class="brush: js">box.rotation.y = t*2;
</pre>

<p>It will rotate the box along the <code>y</code> axis.</p>

<h3 id="Scaling">Scaling</h3>

<p>Add this line below the previous one to scale the torus:</p>

<pre class="brush: js">torus.scaling.z = Math.abs(Math.sin(t*2))+0.5;
</pre>

<p>There's a little bit of adjustment made to make the animation look and feel nice. You can experiment with the values and see how it affects the animation.</p>

<h3 id="Moving">Moving</h3>

<p>By changing the position of the cylinder directly we can move it on the scene — add this line below the previous one:</p>

<pre class="brush: js">cylinder.position.y = Math.sin(t*3);
</pre>

<p>The cylinder will float up and down on the <code>y</code> axis thanks to the <code>Math.sin()</code> function.</p>

<h2 id="Conclusion">Conclusion</h2>

<p>Here's the final code listing, along with a viewable live example:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/8r66fdvp/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/Babylon.js/shapes.html">see it on GitHub</a> and <a href="https://github.com/end3r/MDN-Games-3D/">fork the repository</a> if you want to play with it yourself locally. Now you know the basics of Babylon.js engine; happy experimentation!</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://learningbabylonjs.com/">Learning Babylon.js book</a></li>
</ul>
